"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));

var _foundation = _interopRequireDefault(require("../base/foundation"));

/* eslint-disable no-useless-constructor */
class NotificationListFoundation extends _foundation.default {
  addNotice(opts) {
    // let notices = this._adapter.getNotices();
    const notices = this._adapter.getNotices(); // opts = { ...opts, id };
    // if (opts.duration) {
    //     setTimeout(() => {
    //         this.removeNotice(opts.id);
    //     }, opts.duration * 1000);
    // }


    this._adapter.updateNotices([...notices, opts]); // return id;

  }

  removeNotice(id) {
    let notices = this._adapter.getNotices(); // let notices = this._adapter.getNotices();


    const removedItems = [];
    notices = (0, _filter.default)(notices).call(notices, notice => {
      if (notice.id === id) {
        removedItems.push(notice);
        return false;
      }

      return true;
    });

    this._adapter.updateNotices(notices, removedItems); // This must be updated at the same time https://github.com/facebook/react/issues/12312

  }

  destroyAll() {
    const notices = this._adapter.getNotices();

    if (notices.length > 0) {
      this._adapter.updateNotices([], notices);
    }
  }

}

exports.default = NotificationListFoundation;